// Generated by CoffeeScript 1.12.7
var CouldNotLoad, dirname, findModule, instantiateModule, join, makePath, normalize, ref, resolveAsNode, tryCustomPath, tryFind,
  slice = [].slice;

ref = require('path'), normalize = ref.normalize, join = ref.join, dirname = ref.dirname;

makePath = require('./make-path');

CouldNotLoad = require('./could-not-load');

instantiateModule = require('./instantiate-module');

tryCustomPath = function(opts) {
  var fullPath, getCustomPath;
  getCustomPath = opts.getCustomPath;
  fullPath = getCustomPath(opts);
  return {
    instance: instantiateModule(fullPath),
    path: fullPath
  };
};

findModule = function(opts) {
  var base, callers, e, fileName, fullPath, getCustomPath;
  base = opts.base, fileName = opts.fileName, callers = opts.callers, getCustomPath = opts.getCustomPath;
  fullPath = makePath(base, fileName, callers);
  try {
    return {
      instance: instantiateModule(fullPath),
      path: fullPath
    };
  } catch (error) {
    e = error;
    if (getCustomPath != null) {
      return tryCustomPath(opts);
    } else if (callers.length > 0) {
      return findModule(base, fileName, callers.slice(0, -1));
    } else {
      throw e;
    }
  }
};

tryFind = function(opts) {
  var base, callers, e, e2, fileName;
  base = opts.base, fileName = opts.fileName, callers = opts.callers;
  try {
    return {
      instance: instantiateModule(fileName),
      path: fileName
    };
  } catch (error) {
    e = error;
    if (e.code === 'MODULE_NOT_FOUND') {
      try {
        return findModule(opts);
      } catch (error) {
        e2 = error;
        throw new CouldNotLoad(base, fileName, callers, e);
      }
    } else {
      return {
        instance: {},
        path: makePath(base, fileName, callers)
      };
    }
  }
};

resolveAsNode = function(opts) {
  var alternative, base, callers, e, fileName, fullPath, paths;
  base = opts.base, fileName = opts.fileName, callers = opts.callers;
  paths = callers.map(function(item) {
    return base + "/node_modules/" + item;
  });
  paths.push(base);
  try {
    fullPath = require.resolve(fileName, {
      paths: paths
    });
  } catch (error) {
    e = error;
    alternative = normalize(join.apply(null, slice.call(callers).concat([fileName])));
    fullPath = require.resolve(alternative, {
      paths: paths
    });
  }
  return fullPath.replace(/\.js$/, '');
};

exports.instance = function(opts) {
  if (typeof window === 'undefined') {
    return require(resolveAsNode(opts));
  }
  return tryFind(opts).instance;
};

exports.path = function(opts) {
  if (typeof window === 'undefined') {
    return resolveAsNode(opts);
  }
  return tryFind(opts).path;
};
